commit 3f020d7024e26c1f159e30f5be2dc4f2f5affc07
Author: malc <av1474@comtv.ru>
Date:   Mon Feb 8 12:04:56 2010 +0300

    Revert "On some systems printf is a macro"
    
    This reverts commit bc5b6004588ad17370e0416e40b4aa9cf977023b.

diff --git a/qemu-img.c b/qemu-img.c
index bbfeea1..cbba4fc 100644
--- a/qemu-img.c
+++ b/qemu-img.c
@@ -58,41 +58,41 @@ static void format_print(void *opaque, const char *name)
 /* Please keep in synch with qemu-img.texi */
 static void help(void)
 {
-    (printf)("qemu-img version " QEMU_VERSION ", Copyright (c) 2004-2008 Fabrice Bellard\n"
-             "usage: qemu-img command [command options]\n"
-             "QEMU disk image utility\n"
-             "\n"
-             "Command syntax:\n"
+    printf("qemu-img version " QEMU_VERSION ", Copyright (c) 2004-2008 Fabrice Bellard\n"
+           "usage: qemu-img command [command options]\n"
+           "QEMU disk image utility\n"
+           "\n"
+           "Command syntax:\n"
 #define DEF(option, callback, arg_string)        \
            "  " arg_string "\n"
 #include "qemu-img-cmds.h"
 #undef DEF
 #undef GEN_DOCS
-             "\n"
-             "Command parameters:\n"
-             "  'filename' is a disk image filename\n"
-             "  'fmt' is the disk image format. It is guessed automatically in most cases\n"
-             "  'size' is the disk image size in bytes. Optional suffixes\n"
-             "    'k' or 'K' (kilobyte, 1024), 'M' (megabyte, 1024k), 'G' (gigabyte, 1024M)\n"
-             "    and T (terabyte, 1024G) are supported. 'b' is ignored.\n"
-             "  'output_filename' is the destination disk image filename\n"
-             "  'output_fmt' is the destination format\n"
-             "  'options' is a comma separated list of format specific options in a\n"
-             "    name=value format. Use -o ? for an overview of the options supported by the\n"
-             "    used format\n"
-             "  '-c' indicates that target image must be compressed (qcow format only)\n"
-             "  '-u' enables unsafe rebasing. It is assumed that old and new backing file\n"
-             "       match exactly. The image doesn't need a working backing file before\n"
-             "       rebasing in this case (useful for renaming the backing file)\n"
-             "  '-h' with or without a command shows this help and lists the supported formats\n"
-             "\n"
-             "Parameters to snapshot subcommand:\n"
-             "  'snapshot' is the name of the snapshot to create, apply or delete\n"
-             "  '-a' applies a snapshot (revert disk to saved state)\n"
-             "  '-c' creates a snapshot\n"
-             "  '-d' deletes a snapshot\n"
-             "  '-l' lists all snapshots in the given image\n"
-        );
+           "\n"
+           "Command parameters:\n"
+           "  'filename' is a disk image filename\n"
+           "  'fmt' is the disk image format. It is guessed automatically in most cases\n"
+           "  'size' is the disk image size in bytes. Optional suffixes\n"
+           "    'k' or 'K' (kilobyte, 1024), 'M' (megabyte, 1024k), 'G' (gigabyte, 1024M)\n"
+           "    and T (terabyte, 1024G) are supported. 'b' is ignored.\n"
+           "  'output_filename' is the destination disk image filename\n"
+           "  'output_fmt' is the destination format\n"
+           "  'options' is a comma separated list of format specific options in a\n"
+           "    name=value format. Use -o ? for an overview of the options supported by the\n"
+           "    used format\n"
+           "  '-c' indicates that target image must be compressed (qcow format only)\n"
+           "  '-u' enables unsafe rebasing. It is assumed that old and new backing file\n"
+           "       match exactly. The image doesn't need a working backing file before\n"
+           "       rebasing in this case (useful for renaming the backing file)\n"
+           "  '-h' with or without a command shows this help and lists the supported formats\n"
+           "\n"
+           "Parameters to snapshot subcommand:\n"
+           "  'snapshot' is the name of the snapshot to create, apply or delete\n"
+           "  '-a' applies a snapshot (revert disk to saved state)\n"
+           "  '-c' creates a snapshot\n"
+           "  '-d' deletes a snapshot\n"
+           "  '-l' lists all snapshots in the given image\n"
+           );
     printf("\nSupported formats:");
     bdrv_iterate_format(format_print, NULL);
     printf("\n");